import json
import pandas as pd
import re
from lxml import etree
from selenium import webdriver
from bs4 import BeautifulSoup
from selenium.webdriver.common.by import By
from selenium.webdriver.support.wait import WebDriverWait
from selenium.webdriver.support import expected_conditions as EC
import time

from zlest.util.etl import est_meta, est_html, add_info

_name_ = 'zhejiangsheng'


def f3(driver, url):
    driver.get(url)
    locator = (By.XPATH, "//div[@class='content']|//div[@class='columnBodyNoBg']")
    WebDriverWait(driver, 20).until(EC.visibility_of_element_located(locator))
    before = len(driver.page_source)
    time.sleep(0.1)
    after = len(driver.page_source)
    i = 0
    while before != after:
        before = len(driver.page_source)
        time.sleep(0.1)
        after = len(driver.page_source)
        i += 1
        if i > 5: break

    page = driver.page_source
    soup = BeautifulSoup(page, 'html.parser')
    div = soup.find('div', class_="content")
    if not div:

        div = soup.find('div', class_="columnBodyNoBg")
    return div


def f1(driver, num):
    locator = (By.XPATH, '//div[@class="listBox ico21bg"]/ul/li[1]/span/a')
    val = WebDriverWait(driver, 20).until(EC.presence_of_element_located(locator)).get_attribute('href')[-20:]
    locator = (By.XPATH, '//span[@class="currentpage"]')
    cnum = WebDriverWait(driver, 10).until(EC.presence_of_element_located(locator)).text

    if int(cnum) != int(num):
        url = re.sub('index1','index1_'+str(num),driver.current_url)
        driver.get(url)

        locator = (By.XPATH, '//div[@class="listBox ico21bg"]/ul/li[1]/span[not(contains(@href,"%s"))]' % val)
        WebDriverWait(driver, 10).until(EC.visibility_of_element_located(locator))

    data = []
    page = driver.page_source
    body = etree.HTML(page)
    content_list = body.xpath('//div[@class="listBox ico21bg"]/ul/li')
    for content in content_list:
        name = content.xpath("./span/a/text()")[0].strip()
        ggstart_time = content.xpath("./ii/text()")[0].strip()
        url = content.xpath("./span/a/@href")[0].strip()
        temp = [name, ggstart_time, url]
        data.append(temp)
    df = pd.DataFrame(data=data)
    df['info'] = None
    return df


def f2(driver):
    locator = (By.XPATH, '//span[@class="total"]')
    txt = WebDriverWait(driver, 30).until(EC.presence_of_element_located(locator)).text

    total_page = re.findall('(\d+)', txt)[0]
    driver.quit()
    return int(total_page)


data = [
    #
    ["gcjs_zhaobiao_gg",
     "http://www.zjsafety.gov.cn/cn/index1.shtml",
     ["name", "ggstart_time", "href", "info"], f1, f2],

]


def work(conp, **arg):
    est_meta(conp, data=data, diqu="浙江省", **arg)
    est_html(conp, f=f3, **arg)


if __name__ == '__main__':
    # driver = webdriver.Chrome()
    # url = "http://www.zjsafety.gov.cn/cn/index1.shtml"
    # driver.get(url)
    # f1(driver, 2)
    #
    # print(f2(driver))

    work(conp=["postgres", "since2015", "192.168.3.171", "zlest", "zhejiangsheng"])
